const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const products = sequelize.define(
    'products',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

sku: {
        type: DataTypes.TEXT,
      
      

      },

product_type: {
        type: DataTypes.ENUM,
      
      

        values: [

"goods",


"service"

        ],

      },

description: {
        type: DataTypes.TEXT,
      
      

      },

sales_price: {
        type: DataTypes.DECIMAL,
      
      

      },

purchase_price: {
        type: DataTypes.DECIMAL,
      
      

      },

track_inventory: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

reorder_level: {
        type: DataTypes.INTEGER,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  products.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity













    db.products.hasMany(db.inventory_items, {
      as: 'inventory_items_product',
      foreignKey: {
          name: 'productId',
      },
      constraints: false,
    });



    db.products.hasMany(db.quote_lines, {
      as: 'quote_lines_product',
      foreignKey: {
          name: 'productId',
      },
      constraints: false,
    });



    db.products.hasMany(db.invoice_lines, {
      as: 'invoice_lines_product',
      foreignKey: {
          name: 'productId',
      },
      constraints: false,
    });



    db.products.hasMany(db.bill_lines, {
      as: 'bill_lines_product',
      foreignKey: {
          name: 'productId',
      },
      constraints: false,
    });











//end loop



    db.products.belongsTo(db.organizations, {
      as: 'organization',
      foreignKey: {
        name: 'organizationId',
      },
      constraints: false,
    });

    db.products.belongsTo(db.accounts, {
      as: 'sales_account',
      foreignKey: {
        name: 'sales_accountId',
      },
      constraints: false,
    });

    db.products.belongsTo(db.accounts, {
      as: 'purchase_account',
      foreignKey: {
        name: 'purchase_accountId',
      },
      constraints: false,
    });

    db.products.belongsTo(db.tax_rates, {
      as: 'tax_rate',
      foreignKey: {
        name: 'tax_rateId',
      },
      constraints: false,
    });



    db.products.hasMany(db.file, {
      as: 'images',
      foreignKey: 'belongsToId',
      constraints: false,
      scope: {
        belongsTo: db.products.getTableName(),
        belongsToColumn: 'images',
      },
    });


    db.products.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.products.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return products;
};


